commit 50a6abf200c5116e9b86f12afbcc973ccd021261
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Oct 31 12:55:40 2025 +0000

    Testsuite: expand store_free() checking

diff --git a/src/src/deliver.c b/src/src/deliver.c
index 497c62e81..94dc092a3 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -9088,6 +9088,38 @@ fail:
 #endif
 }
 
+
+/* When running with debug_store this is called on every store_reset(). Walk all
+the address lists we maintain checking that none of the pointers are in the region
+being freed. */
+/*XXX what about all the pointers contained in the addr?
+If implemented, beware unbounded recursion. */
+
+static void
+check_addr_list(const uschar * name, const address_item * a,
+  void (*f)(const uschar*, const uschar*, void*), void * ctx)
+{
+while (a)
+  {
+  f(name, CUS a, ctx);	/* We lie about the data type */
+  a = a->next;
+  }
+}
+
+void
+check_deliver_addrs_not_freed(void (*f)(const uschar*, const uschar*, void*), void * ctx)
+{
+check_addr_list(US"(addr_defer)",	addr_defer,	f, ctx);
+check_addr_list(US"(addr_failed)",	addr_failed,	f, ctx);
+check_addr_list(US"(addr_fallback)",	addr_fallback,	f, ctx);
+check_addr_list(US"(addr_local)",	addr_local,	f, ctx);
+check_addr_list(US"(addr_new)",		addr_new,	f, ctx);
+check_addr_list(US"(addr_remote)",	addr_remote,	f, ctx);
+check_addr_list(US"(addr_route)",	addr_route,	f, ctx);
+check_addr_list(US"(addr_succeed)",	addr_succeed,	f, ctx);
+check_addr_list(US"(addr_duplicate)",	addr_duplicate, f, ctx);
+}
+
 /* vi: aw ai sw=2
 */
 /* End of deliver.c */
diff --git a/src/src/expand.c b/src/src/expand.c
index 554d68ba6..9bfa39fdc 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -9017,15 +9017,18 @@ typedef struct {
   const uschar *var_data;
 } err_ctx;
 
-/* Called via tree_walk, which allows nonconst name/data.  Our usage is const. */
+/* Called via tree_walk, which allows nonconst name/data. Our usage is const. */
+typedef void (*twalk_compat)(uschar *, uschar *, void *);
+
 static void
-assert_variable_notin(uschar * var_name, uschar * var_data, void * ctx)
+assert_variable_notin(const uschar * var_name, const uschar * var_data,
+  void * ctx)
 {
 err_ctx * e = ctx;
 if (var_data >= e->region_start  &&  var_data < e->region_end)
   {
-  e->var_name = CUS var_name;
-  e->var_data = CUS var_data;
+  e->var_name = var_name;
+  e->var_data = var_data;
   }
 }
 
@@ -9036,8 +9039,8 @@ err_ctx e = { .region_start = ptr, .region_end = US ptr + len,
 	      .var_name = NULL, .var_data = NULL };
 
 /* check acl_ variables */
-tree_walk(acl_var_c, assert_variable_notin, &e);
-tree_walk(acl_var_m, assert_variable_notin, &e);
+tree_walk(acl_var_c, (twalk_compat) assert_variable_notin, &e);
+tree_walk(acl_var_m, (twalk_compat) assert_variable_notin, &e);
 
 /* check auth<n> variables.
 assert_variable_notin() treats as const, so deconst is safe. */
@@ -9056,10 +9059,13 @@ for (var_entry * v = var_table; v < var_table + nelem(var_table); v++)
     assert_variable_notin(US v->name, *(USS v->value), &e);
 
 /* check dns and address trees */
-tree_walk(tree_dns_fails,     assert_variable_notin, &e);
-tree_walk(tree_duplicates,    assert_variable_notin, &e);
-tree_walk(tree_nonrecipients, assert_variable_notin, &e);
-tree_walk(tree_unusable,      assert_variable_notin, &e);
+tree_walk(tree_dns_fails,     (twalk_compat) assert_variable_notin, &e);
+tree_walk(tree_duplicates,    (twalk_compat) assert_variable_notin, &e);
+tree_walk(tree_nonrecipients, (twalk_compat) assert_variable_notin, &e);
+tree_walk(tree_unusable,      (twalk_compat) assert_variable_notin, &e);
+
+/* check address-lists */
+check_deliver_addrs_not_freed(assert_variable_notin, &e);
 
 if (e.var_name)
   log_write_die(0, LOG_MAIN,
diff --git a/src/src/functions.h b/src/src/functions.h
index a29dddbed..223723b81 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -144,6 +144,7 @@ extern void    bits_set(unsigned int *, size_t, int *);
 extern void    cancel_cutthrough_connection(BOOL, const uschar *);
 extern gstring *cat_file(FILE *, gstring *, const uschar *);
 extern gstring *cat_file_tls(void *, gstring *, const uschar *);
+extern void    check_deliver_addrs_not_freed(void (*)(const uschar*, const uschar*, void*), void *);
 extern int     check_host(void *, const uschar *, const uschar **, uschar **);
 extern uschar **child_exec_exim(int, BOOL, int *, BOOL, int, ...);
 extern pid_t   child_open_exim_function(int *, const uschar *);
diff --git a/src/src/transport.c b/src/src/transport.c
index d88653964..a59a5ae3d 100644
--- a/src/src/transport.c
+++ b/src/src/transport.c
@@ -705,10 +705,10 @@ Returns:    FALSE if writing failed
 */
 
 static BOOL
-write_env_to(address_item *p, struct aci **pplist, struct aci **pdlist,
-  BOOL *first, transport_ctx * tctx)
+write_env_to(address_item * p, struct aci ** pplist, struct aci ** pdlist,
+  BOOL * first, transport_ctx * tctx)
 {
-address_item *pp;
+address_item * pp;
 struct aci *ppp;
 
 /* Do nothing if we have already handled this address. If not, remember it
@@ -725,8 +725,7 @@ ppp->ptr = p;
 
 for (pp = p;; pp = pp->parent)
   {
-  address_item *dup;
-  for (dup = addr_duplicate; dup; dup = dup->next)
+  for (address_item * dup = addr_duplicate; dup; dup = dup->next)
     if (dup->dupof == pp)   /* a dup of our address */
       if (!write_env_to(dup, pplist, pdlist, first, tctx))
 	return FALSE;

